﻿using Coscine.Api.Core.Entities.Models;
using Coscine.Api.Core.Shared.RequestFeatures;
using System.Linq.Expressions;
using VDS.RDF;

namespace Coscine.Api.Core.Repository.Contracts;

public interface IUserRepository
{
    Task<PagedEnumerable<User>> GetPagedAsync(UserAdminParameters userParameters, bool trackChanges);

    Task<IEnumerable<User>> GetFirstTenUsersAsync(UserSearchParameters userParameters, bool trackChanges);

    /// <summary>
    /// Retrieves a user by the given id with optional includes for related data.
    /// </summary>
    /// <param name="userId">The id of the user to be retrieved.</param>
    /// <param name="trackChanges">Whether or not to track changes to the retrieved user.</param>
    /// <param name="includeProperties">Expressions for the additional data to be retrieved related to the user.</param>
    /// <returns>A Task resulting in the user matching the given id, or <c>null</c> if no such user exists.</returns>
    /// <remarks>
    /// This method uses Entity Framework Core's <c>Include</c> method to eagerly load related data. The <c>includeProperties</c> parameter allows you to specify which related data to load.
    ///
    /// If there are multiple <c>includeProperties</c>, <c>AsSplitQuery</c> is used to split the query into multiple queries - one for the main user data and one for each included related data.
    /// This can improve performance if the SQL generated by a single query is too complex, but it may increase the number of round trips to the database.
    ///
    /// It's best to use <c>includeProperties</c> sparingly, only for data that's needed immediately, to avoid unnecessary database load.
    /// </remarks>
    Task<User?> GetAsync(Guid userId, bool trackChanges, params Expression<Func<User, object?>>[] includeProperties);

    Task<User?> GetAsync(Guid userId, bool trackChanges);

    void Create(User user);

    void SoftDelete(User user);

    Task<User> MergeAsync(Guid fromUserId, Guid toUserId);

    Uri GenerateGraphName(User user);

    Task DeleteGraphAsync(User user);

    Task UpdateGraphAsync(User user);

    Task<IGraph> CreateGraphAsync(User user);
}